monads-tf-0.3.0.1: Monad classes, using type families

Copyright | (c) Andy Gill 2001 (c) Oregon Graduate Institute of Science and Technology 2001
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | non-portable (type families)
Safe Haskell | None
Language | GHC2021

Control.Monad.Writer.Lazy

Contents

- MonadWriter class
- The Writer monad
- The WriterT monad transformer

Description

Lazy writer monads.

Inspired by the paper /Functional Programming with Overloading and Higher-Order Polymorphism/, Mark P Jones (http://web.cecs.pdx.edu/~mpj/pubs/springschool.html) Advanced School of Functional Programming, 1995.

Synopsis

- class (Monoid (WriterType m), Monad m) => MonadWriter (m :: Type -> Type) where
  - type WriterType (m :: Type -> Type)
  - tell :: WriterType m -> m ()
  - listen :: m a -> m (a, WriterType m)
  - pass :: m (a, WriterType m -> WriterType m) -> m a
- listens :: MonadWriter m => (WriterType m -> b) -> m a -> m (a, b)
- censor :: MonadWriter m => (WriterType m -> WriterType m) -> m a -> m a
- type Writer w = WriterT w Identity
- runWriter :: Writer w a -> (a, w)
- execWriter :: Writer w a -> w
- mapWriter :: ((a, w) -> (b, w')) -> Writer w a -> Writer w' b
- newtype WriterT w (m :: Type -> Type) a = WriterT {
  - runWriterT :: m (a, w)
  }
- execWriterT :: Monad m => WriterT w m a -> m w
- mapWriterT :: (m (a, w) -> n (b, w')) -> WriterT w m a -> WriterT w' n b
- module Control.Monad
- module Control.Monad.Fix
- module Control.Monad.Trans
- module Data.Monoid

# MonadWriter class

class (Monoid (WriterType m), Monad m) => MonadWriter (m :: Type -> Type) where Source #

Associated Types

type WriterType (m :: Type -> Type) Source #

Methods

tell :: WriterType m -> m () Source #

Shout to the monad what you want to be heard. The monad carries this packet upwards, merging it if needed (hence the `Monoid` requirement).

listen :: m a -> m (a, WriterType m) Source #

Listen to a monad acting, and return what the monad "said".

pass :: m (a, WriterType m -> WriterType m) -> m a Source #

Provide a writer transformer which changes internals of the written object.

#### Instances

Instances details

MonadWriter m => MonadWriter (MaybeT m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (MaybeT m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (MaybeT m) = WriterType m

Methods

tell :: WriterType (MaybeT m) -> MaybeT m () Source #

listen :: MaybeT m a -> MaybeT m (a, WriterType (MaybeT m)) Source #

pass :: MaybeT m (a, WriterType (MaybeT m) -> WriterType (MaybeT m)) -> MaybeT m a Source #

MonadWriter m => MonadWriter (ExceptT e m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (ExceptT e m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (ExceptT e m) = WriterType m

Methods

tell :: WriterType (ExceptT e m) -> ExceptT e m () Source #

listen :: ExceptT e m a -> ExceptT e m (a, WriterType (ExceptT e m)) Source #

pass :: ExceptT e m (a, WriterType (ExceptT e m) -> WriterType (ExceptT e m)) -> ExceptT e m a Source #

MonadWriter m => MonadWriter (IdentityT m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (IdentityT m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (IdentityT m) = WriterType m

Methods

tell :: WriterType (IdentityT m) -> IdentityT m () Source #

listen :: IdentityT m a -> IdentityT m (a, WriterType (IdentityT m)) Source #

pass :: IdentityT m (a, WriterType (IdentityT m) -> WriterType (IdentityT m)) -> IdentityT m a Source #

MonadWriter m => MonadWriter (ReaderT r m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (ReaderT r m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (ReaderT r m) = WriterType m

Methods

tell :: WriterType (ReaderT r m) -> ReaderT r m () Source #

listen :: ReaderT r m a -> ReaderT r m (a, WriterType (ReaderT r m)) Source #

pass :: ReaderT r m (a, WriterType (ReaderT r m) -> WriterType (ReaderT r m)) -> ReaderT r m a Source #

MonadWriter m => MonadWriter (StateT s m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (StateT s m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (StateT s m) = WriterType m

Methods

tell :: WriterType (StateT s m) -> StateT s m () Source #

listen :: StateT s m a -> StateT s m (a, WriterType (StateT s m)) Source #

pass :: StateT s m (a, WriterType (StateT s m) -> WriterType (StateT s m)) -> StateT s m a Source #

MonadWriter m => MonadWriter (StateT s m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (StateT s m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (StateT s m) = WriterType m

Methods

tell :: WriterType (StateT s m) -> StateT s m () Source #

listen :: StateT s m a -> StateT s m (a, WriterType (StateT s m)) Source #

pass :: StateT s m (a, WriterType (StateT s m) -> WriterType (StateT s m)) -> StateT s m a Source #

(Monoid w, Monad m) => MonadWriter (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (WriterT w m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (WriterT w m) = w

Methods

tell :: WriterType (WriterT w m) -> WriterT w m () Source #

listen :: WriterT w m a -> WriterT w m (a, WriterType (WriterT w m)) Source #

pass :: WriterT w m (a, WriterType (WriterT w m) -> WriterType (WriterT w m)) -> WriterT w m a Source #

(Monoid w, Monad m) => MonadWriter (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (WriterT w m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (WriterT w m) = w

Methods

tell :: WriterType (WriterT w m) -> WriterT w m () Source #

listen :: WriterT w m a -> WriterT w m (a, WriterType (WriterT w m)) Source #

pass :: WriterT w m (a, WriterType (WriterT w m) -> WriterType (WriterT w m)) -> WriterT w m a Source #

(Monoid w, Monad m) => MonadWriter (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (RWST r w s m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (RWST r w s m) = w

Methods

tell :: WriterType (RWST r w s m) -> RWST r w s m () Source #

listen :: RWST r w s m a -> RWST r w s m (a, WriterType (RWST r w s m)) Source #

pass :: RWST r w s m (a, WriterType (RWST r w s m) -> WriterType (RWST r w s m)) -> RWST r w s m a Source #

(Monoid w, Monad m) => MonadWriter (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (RWST r w s m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (RWST r w s m) = w

Methods

tell :: WriterType (RWST r w s m) -> RWST r w s m () Source #

listen :: RWST r w s m a -> RWST r w s m (a, WriterType (RWST r w s m)) Source #

pass :: RWST r w s m (a, WriterType (RWST r w s m) -> WriterType (RWST r w s m)) -> RWST r w s m a Source #

listens :: MonadWriter m => (WriterType m -> b) -> m a -> m (a, b) Source #

``listens` f m` is an action that executes the action `m` and adds the result of applying `f` to the output to the value of the computation.

-     listens f m = liftM (id *** f) (listen m)

censor :: MonadWriter m => (WriterType m -> WriterType m) -> m a -> m a Source #

``censor` f m` is an action that executes the action `m` and applies the function `f` to its output, leaving the return value unchanged.

-     censor f m = pass (liftM (\ x -> (x,f)) m)

# The Writer monad

type Writer w = WriterT w Identity Source #

A writer monad parameterized by the type `w` of output to accumulate.

The `return` function produces the output `mempty`, while `m `>>=` k` combines the outputs of the subcomputations using `mappend` (also known as `<>`):

runWriter :: Writer w a -> (a, w) Source #

Unwrap a writer computation as a (result, output) pair. (The inverse of `writer`.)

execWriter :: Writer w a -> w Source #

Extract the output from a writer computation.

-     execWriter m = snd (runWriter m)

mapWriter :: ((a, w) -> (b, w')) -> Writer w a -> Writer w' b Source #

Map both the return value and output of a computation using the given function.

-     runWriter (mapWriter f m) = f (runWriter m)

# The WriterT monad transformer

newtype WriterT w (m :: Type -> Type) a Source #

A writer monad parameterized by:

- `w` - the output to accumulate.
- `m` - The inner monad.

The `return` function produces the output `mempty`, while `m `>>=` k` combines the outputs of the subcomputations using `mappend` (also known as `<>`):

Constructors

WriterT |

Fields

- runWriterT :: m (a, w)

#### Instances

Instances details

Monoid w => MonadTrans (WriterT w) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods lift :: Monad m => m a -> WriterT w m a Source #
(Monoid w, MonadIO m) => MonadIO (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods liftIO :: IO a -> WriterT w m a Source #
(Monoid w, MonadZip m) => MonadZip (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods mzip :: WriterT w m a -> WriterT w m b -> WriterT w m (a, b) Source # mzipWith :: (a -> b -> c) -> WriterT w m a -> WriterT w m b -> WriterT w m c Source # munzip :: WriterT w m (a, b) -> (WriterT w m a, WriterT w m b) Source #
(Eq w, Eq1 m) => Eq1 (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods liftEq :: (a -> b -> Bool) -> WriterT w m a -> WriterT w m b -> Bool Source #
(Ord w, Ord1 m) => Ord1 (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods liftCompare :: (a -> b -> Ordering) -> WriterT w m a -> WriterT w m b -> Ordering Source #
(Read w, Read1 m) => Read1 (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods liftReadsPrec :: (Int -> ReadS a) -> ReadS [a] -> Int -> ReadS (WriterT w m a) Source # liftReadList :: (Int -> ReadS a) -> ReadS [a] -> ReadS [WriterT w m a] Source # liftReadPrec :: ReadPrec a -> ReadPrec [a] -> ReadPrec (WriterT w m a) Source # liftReadListPrec :: ReadPrec a -> ReadPrec [a] -> ReadPrec [WriterT w m a] Source #
(Show w, Show1 m) => Show1 (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods liftShowsPrec :: (Int -> a -> ShowS) -> ([a] -> ShowS) -> Int -> WriterT w m a -> ShowS Source # liftShowList :: (Int -> a -> ShowS) -> ([a] -> ShowS) -> [WriterT w m a] -> ShowS Source #
Contravariant m => Contravariant (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods contramap :: (a' -> a) -> WriterT w m a -> WriterT w m a' Source # (>$) :: b -> WriterT w m b -> WriterT w m a Source #
(Monoid w, Alternative m) => Alternative (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods empty :: WriterT w m a Source # (<|>) :: WriterT w m a -> WriterT w m a -> WriterT w m a Source # some :: WriterT w m a -> WriterT w m [a] Source # many :: WriterT w m a -> WriterT w m [a] Source #
(Monoid w, Applicative m) => Applicative (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods pure :: a -> WriterT w m a Source # (<*>) :: WriterT w m (a -> b) -> WriterT w m a -> WriterT w m b Source # liftA2 :: (a -> b -> c) -> WriterT w m a -> WriterT w m b -> WriterT w m c Source # (*>) :: WriterT w m a -> WriterT w m b -> WriterT w m b Source # (<*) :: WriterT w m a -> WriterT w m b -> WriterT w m a Source #
Functor m => Functor (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods fmap :: (a -> b) -> WriterT w m a -> WriterT w m b Source # (<$) :: a -> WriterT w m b -> WriterT w m a Source #
(Monoid w, Monad m) => Monad (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods (>>=) :: WriterT w m a -> (a -> WriterT w m b) -> WriterT w m b Source # (>>) :: WriterT w m a -> WriterT w m b -> WriterT w m b Source # return :: a -> WriterT w m a Source #
(Monoid w, MonadPlus m) => MonadPlus (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods mzero :: WriterT w m a Source # mplus :: WriterT w m a -> WriterT w m a -> WriterT w m a Source #
(Monoid w, MonadFail m) => MonadFail (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods fail :: String -> WriterT w m a Source #
(Monoid w, MonadFix m) => MonadFix (WriterT w m) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods mfix :: (a -> WriterT w m a) -> WriterT w m a Source #
Foldable f => Foldable (WriterT w f) |

Instance details

Defined in Control.Monad.Trans.Writer.Lazy

Methods

fold :: Monoid m => WriterT w f m -> m Source #

foldMap :: Monoid m => (a -> m) -> WriterT w f a -> m Source #

foldMap' :: Monoid m => (a -> m) -> WriterT w f a -> m Source #

foldr :: (a -> b -> b) -> b -> WriterT w f a -> b Source #

foldr' :: (a -> b -> b) -> b -> WriterT w f a -> b Source #

foldl :: (b -> a -> b) -> b -> WriterT w f a -> b Source #

foldl' :: (b -> a -> b) -> b -> WriterT w f a -> b Source #

foldr1 :: (a -> a -> a) -> WriterT w f a -> a Source #

foldl1 :: (a -> a -> a) -> WriterT w f a -> a Source #

toList :: WriterT w f a -> [a] Source #

null :: WriterT w f a -> Bool Source #

length :: WriterT w f a -> Int Source #

elem :: Eq a => a -> WriterT w f a -> Bool Source #

maximum :: Ord a => WriterT w f a -> a Source #

minimum :: Ord a => WriterT w f a -> a Source #

sum :: Num a => WriterT w f a -> a Source #

product :: Num a => WriterT w f a -> a Source #

Traversable f => Traversable (WriterT w f) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods traverse :: Applicative f0 => (a -> f0 b) -> WriterT w f a -> f0 (WriterT w f b) Source # sequenceA :: Applicative f0 => WriterT w f (f0 a) -> f0 (WriterT w f a) Source # mapM :: Monad m => (a -> m b) -> WriterT w f a -> m (WriterT w f b) Source # sequence :: Monad m => WriterT w f (m a) -> m (WriterT w f a) Source #
(Monoid w, MonadCont m) => MonadCont (WriterT w m) Source # |
Instance details Defined in Control.Monad.Cont.Class Methods callCC :: ((a -> WriterT w m b) -> WriterT w m a) -> WriterT w m a Source #
(Monoid w, MonadError m) => MonadError (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (WriterT w m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (WriterT w m) = ErrorType m

Methods

throwError :: ErrorType (WriterT w m) -> WriterT w m a Source #

catchError :: WriterT w m a -> (ErrorType (WriterT w m) -> WriterT w m a) -> WriterT w m a Source #

(Monoid w, MonadReader m) => MonadReader (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (WriterT w m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m

Methods

ask :: WriterT w m (EnvType (WriterT w m)) Source #

local :: (EnvType (WriterT w m) -> EnvType (WriterT w m)) -> WriterT w m a -> WriterT w m a Source #

(Monoid w, MonadState m) => MonadState (WriterT w m) Source # |

Instance details

Defined in Control.Monad.State.Class

Associated Types

type StateType (WriterT w m) |
Instance details Defined in Control.Monad.State.Class type StateType (WriterT w m) = StateType m

Methods

get :: WriterT w m (StateType (WriterT w m)) Source #

put :: StateType (WriterT w m) -> WriterT w m () Source #

(Monoid w, Monad m) => MonadWriter (WriterT w m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (WriterT w m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (WriterT w m) = w

Methods

tell :: WriterType (WriterT w m) -> WriterT w m () Source #

listen :: WriterT w m a -> WriterT w m (a, WriterType (WriterT w m)) Source #

pass :: WriterT w m (a, WriterType (WriterT w m) -> WriterType (WriterT w m)) -> WriterT w m a Source #

Generic (WriterT w m a) |

Instance details

Defined in Control.Monad.Trans.Writer.Lazy

Associated Types

type Rep (WriterT w m a) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy type Rep (WriterT w m a) = D1 ('MetaData "WriterT" "Control.Monad.Trans.Writer.Lazy" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "WriterT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runWriterT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (m (a, w)))))

Methods

from :: WriterT w m a -> Rep (WriterT w m a) x Source #

to :: Rep (WriterT w m a) x -> WriterT w m a Source #

(Read w, Read1 m, Read a) => Read (WriterT w m a) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods readsPrec :: Int -> ReadS (WriterT w m a) Source # readList :: ReadS [WriterT w m a] Source # readPrec :: ReadPrec (WriterT w m a) Source # readListPrec :: ReadPrec [WriterT w m a] Source #
(Show w, Show1 m, Show a) => Show (WriterT w m a) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods showsPrec :: Int -> WriterT w m a -> ShowS Source # show :: WriterT w m a -> String Source # showList :: [WriterT w m a] -> ShowS Source #
(Eq w, Eq1 m, Eq a) => Eq (WriterT w m a) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy Methods (==) :: WriterT w m a -> WriterT w m a -> Bool Source # (/=) :: WriterT w m a -> WriterT w m a -> Bool Source #
(Ord w, Ord1 m, Ord a) => Ord (WriterT w m a) |

Instance details

Defined in Control.Monad.Trans.Writer.Lazy

Methods

compare :: WriterT w m a -> WriterT w m a -> Ordering Source #

(<) :: WriterT w m a -> WriterT w m a -> Bool Source #

(<=) :: WriterT w m a -> WriterT w m a -> Bool Source #

(>) :: WriterT w m a -> WriterT w m a -> Bool Source #

(>=) :: WriterT w m a -> WriterT w m a -> Bool Source #

max :: WriterT w m a -> WriterT w m a -> WriterT w m a Source #

min :: WriterT w m a -> WriterT w m a -> WriterT w m a Source #

type ErrorType (WriterT w m) Source # |
Instance details Defined in Control.Monad.Except.Class type ErrorType (WriterT w m) = ErrorType m
type EnvType (WriterT w m) Source # |
Instance details Defined in Control.Monad.Reader.Class type EnvType (WriterT w m) = EnvType m
type StateType (WriterT w m) Source # |
Instance details Defined in Control.Monad.State.Class type StateType (WriterT w m) = StateType m
type WriterType (WriterT w m) Source # |
Instance details Defined in Control.Monad.Writer.Class type WriterType (WriterT w m) = w
type Rep (WriterT w m a) |
Instance details Defined in Control.Monad.Trans.Writer.Lazy type Rep (WriterT w m a) = D1 ('MetaData "WriterT" "Control.Monad.Trans.Writer.Lazy" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "WriterT" 'PrefixI 'True) (S1 ('MetaSel ('Just "runWriterT") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (m (a, w)))))

execWriterT :: Monad m => WriterT w m a -> m w Source #

Extract the output from a writer computation.

-     execWriterT m = liftM snd (runWriterT m)

mapWriterT :: (m (a, w) -> n (b, w')) -> WriterT w m a -> WriterT w' n b Source #

Map both the return value and output of a computation using the given function.

-     runWriterT (mapWriterT f m) = f (runWriterT m)

module Control.Monad

module Control.Monad.Fix

module Control.Monad.Trans

module Data.Monoid